//+------------------------------------------------------------------+
//|                                            ytg_DveMashki_ind.mq4 |
//|                                                     Yuriy Tokman |
//|                                            yuriytokman@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Yuriy Tokman"
#property link      "yuriytokman@gmail.com"

//  asystem2000@gmail.com

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Red
#property indicator_width1 4
#property indicator_width2 4

//----

extern string TimeFrame = "Current time frame";
extern int ma_1 = 28;
extern int ma_2 = 144;
extern int method = 3;
extern int price = 0;
extern int signal = 14;
extern int s_method = 0;
extern int signal2 = 70;
extern int s_method2 = 0;
extern color color1 = LimeGreen;
extern color color2 = Red;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double MACD_Map[];
double SignalLine[];
double SignalLine2[];
double SignalMap2[];
double SignalMap[];

//----
//
//
//
//
//

string indicatorFileName;
bool   returnBars;
int    timeFrame;
//\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n
int init()
  {
//---- indicators
   IndicatorBuffers(7);
   SetIndexStyle(0,DRAW_HISTOGRAM, 0, 4, color1);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM, 0, 4, color2);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexBuffer(2, SignalLine);
   SetIndexBuffer(3, SignalLine2);  
   SetIndexBuffer(4,MACD_Map);
   SetIndexBuffer(5,SignalMap);     
   SetIndexBuffer(6,SignalMap2);   
    
    //
    //
    //
    //
    //
    
    indicatorFileName = WindowExpertName();
    returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
    timeFrame         = stringToTimeFrame(TimeFrame);
   
    //
    //
    //
    //
    //
    
   IndicatorShortName(timeFrameToString(timeFrame)+" DveMashki_ind_w_Signals");
return(0);
}

int start()
{
   
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { ExtMapBuffer1[0] = limit+1; return(0); }
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);               
                      ExtMapBuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ma_1,ma_2,method,price,signal,s_method,signal2,s_method2,color1,color2,0,y);
                      ExtMapBuffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ma_1,ma_2,method,price,signal,s_method,signal2,s_method2,color1,color2,1,y);         
               }
     return(0);
     }
     
     //
     //
     //
     //
     //
       
   if(Bars<=10) return(0);
   int ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   while(pos>=0)
     { 
      ExtMapBuffer1[pos]=iMA(Symbol(),0,ma_1,0,method,price,pos);
      ExtMapBuffer2[pos]=iMA(Symbol(),0,ma_2,0,method,price,pos);
      MACD_Map[pos]=ExtMapBuffer1[pos]-ExtMapBuffer2[pos];
 	   pos--;
    }
   pos=Bars-ExtCountedBars-1;  
   
   while(pos>=0) 
     {
      SignalMap[pos]=  iMAOnArray(MACD_Map,0,signal,0,s_method,pos);
      SignalLine[pos]= NormalizeDouble(ExtMapBuffer2[pos]+SignalMap[pos],Digits);
    
      SignalMap2[pos]=  iMAOnArray(MACD_Map,0,signal2,0,s_method2,pos);
      SignalLine2[pos]= NormalizeDouble(SignalMap2[pos]+ExtMapBuffer2[pos],Digits);
      pos--;
     } 

   return(0);
  }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}